// nuttall25.cpp
//

#include "stdafx.h"
#include "stdlib.h"
#include "stdio.h"
#include "time.h"
#include "math.h"
#include "string.h"

#pragma warning(disable: 4996)
#define _CRT_SECURE_NO_WARNINGS
#define LARGENUMBER 1.0e+10
#define NUMBSP 100 /* # bulk supply points considered */
#define NUMCONTING 3 /* number of contingency cases considered */
#define ZERO 0
#define LDCPOINTS 11 /* # points on load-duration curve table */
#define RESTORPTS 6
#define REPAIRPTS 4

int bspread,loctyp[NUMBSP];
double OPEX_CAPITAL, TRANSFORMERCOSTMULT, LINECOSTMULT, TRANSFORMERLIFE, OHLINELIFE, UGLINELIFE;
double discrate, capefffactor, tx_fail_rate, ohline_fail_rate, ugline_fail_rate;
double tx_cost_coef, tx_cost_exp, ln_cost_coef, ln_cost_exp, ug_cost_mult;
double tx_repair_limit, line_repair_limit, cable_repair_limit;
int label[NUMBSP], num_tx[NUMBSP], num_ln[NUMBSP], ugflag[NUMBSP], opt_conting[NUMBSP];

double e_above[LDCPOINTS],eabove[NUMBSP][LDCPOINTS];
double EUE, opt_EUE[NUMBSP][NUMCONTING], optim_EUE[NUMBSP];
double o_EUE_norm_tx[NUMBSP], o_EUE_N1_tx[NUMBSP], o_EUE_N2_tx[NUMBSP];
double o_EUE_norm_ln[NUMBSP], o_EUE_N1_ln[NUMBSP], o_EUE_N2_ln[NUMBSP]; 
double oEUE0tx, oEUE0ln, oEUE1tx, oEUE1ln, oEUE2tx, oEUE2ln;
double tot_cost[NUMBSP][NUMCONTING], mintotcost[NUMBSP], vcr[NUMBSP], max_demand[NUMBSP], load_factor[NUMBSP];
double line_length[NUMBSP];
double fixcapm[RESTORPTS], permvacapm[RESTORPTS], fixopm[RESTORPTS], permvaopm[RESTORPTS], hr2restor[RESTORPTS];
double txhr2rep[REPAIRPTS], txfixcapm[REPAIRPTS], txpermvacapm[REPAIRPTS], txfixopm[REPAIRPTS],
txpermvaopm[REPAIRPTS], txsparefixcap[REPAIRPTS], txsparepermvacap[REPAIRPTS], txspareop[REPAIRPTS];
double ohhr2rep[REPAIRPTS], ohfixcapm[REPAIRPTS], ohpermvacapm[REPAIRPTS],
ohfixopm[REPAIRPTS],ohpermvaopm[REPAIRPTS], ughr2rep[REPAIRPTS],
ugfixcapm[REPAIRPTS], ugpermvacapm[REPAIRPTS], ugfixopm[REPAIRPTS], ugpermvaopm[REPAIRPTS];
double txcostmult[REPAIRPTS], ohcostmult[REPAIRPTS], ugcostmult[REPAIRPTS], 
failratemult[REPAIRPTS], linelength[REPAIRPTS];
int otxN,olineN,olrep1,otxrep1,ores1,olrep,otxrep,olrep2,otxrep2,ores2,o2txrep1,o2lrep1;
double ollar, otxlar,ollar2,otxlar2;
double omodnum_tx,omodnum_ln,cmodnum_tx,cmodnum_ln;
double ollar1, otxlar1;
double orestcapswtx2, orestcapswtx1, orestcapswln2, orestcapswln1;
double orcstx2[NUMBSP], orcstx1[NUMBSP], orcsln2[NUMBSP], orcsln1[NUMBSP];
double LAR[NUMBSP][2][NUMCONTING][NUMCONTING]; /* stores lar criteria by bsp, tx or ln, failtype, conting std*/
double bspLAR[2][NUMCONTING][NUMCONTING];

int imax(int a, int b)
{
	int i;

	if (a > b) i = a; else i = b;
	return i;
}
double max(double a, double b)
{
	double f;

	if (a > b) f = a; else f = b;
	return f;
}
int imin(int a, int b)
{
	int i;

	if (a < b) i = a; else i = b;
	return i;
}
double min(double a, double b)
{
	double f;

	if (a < b) f = a; else f = b;
	return f;
}
void read_inputs()
{
	int j, u1, u2, u3, u6, u7;
	double w2, w3, w4, w5, w6, w7, w8, w9, w10, w11;
	double v0, v1, v2, v3, v4, v5, v6, v7, v8, v9, v10;

	/* read static constants */
	scanf("%lf", &w2); OPEX_CAPITAL = w2;		printf("opex_capital_ratio          %4.2lf\n", OPEX_CAPITAL);
	scanf("%lf", &w2); TRANSFORMERCOSTMULT = w2;printf("transformer_cost_multiplier %4.1lf\n", TRANSFORMERCOSTMULT);
	scanf("%lf", &w2); LINECOSTMULT = w2;		printf("line_cost_multiplier        %4.1lf\n", LINECOSTMULT);
	scanf("%lf", &w2); TRANSFORMERLIFE = w2;	printf("transformer_life_in_yrs     %4.1lf\n", TRANSFORMERLIFE);
	scanf("%lf", &w2); OHLINELIFE = w2;			printf("oh_line_life_in_yrs         %4.1lf\n", OHLINELIFE);
	scanf("%lf", &w2); UGLINELIFE = w2;			printf("ug_cable_life_in_yrs        %4.1lf\n", UGLINELIFE);
	scanf("%lf", &w2); discrate = w2;			printf("discount_rate              %5.3lf\n", discrate);
	scanf("%lf", &w2); capefffactor = w2;		printf("capital_efficiency_factor   %4.1lf\n", capefffactor);
	scanf("%lf", &w2); tx_fail_rate = w2;		printf("failures_per_transformer_per_annum              %11.9lf\n", tx_fail_rate);
	scanf("%lf", &w2); ohline_fail_rate = w2;	printf("failures_per_annum_per_100km_oh_line            %6.4lf\n", ohline_fail_rate);
	scanf("%lf", &w2); ugline_fail_rate = w2;	printf("failures_per_annum_per_100km_ug_cable           %6.4lf\n", ugline_fail_rate);
	scanf("%lf", &w2); tx_cost_coef = w2;		printf("coef_for_transformer_cost_function_coef*MVA^exp %6.4lf\n", tx_cost_coef);
	scanf("%lf", &w2); tx_cost_exp = w2;		printf("exponent_for_transformer_cost_function          %6.4lf\n", tx_cost_exp);
	scanf("%lf", &w2); ln_cost_coef = w2;		printf("coef_for_line_cost_function_coef*MVA^exp        %6.4lf\n", ln_cost_coef);
	scanf("%lf", &w2); ln_cost_exp = w2;		printf("exponent_for_line_cost_function                 %6.4lf\n", ln_cost_exp);
	scanf("%lf", &w2); ug_cost_mult = w2;		printf("cost_multiplier_underground_cables              %4.1lf\n", ug_cost_mult);
	scanf("%lf", &w2); tx_repair_limit = w2;	printf("max_hrs_to_replace/repair_transformer       %8.0lf\n", tx_repair_limit);
	scanf("%lf", &w2); line_repair_limit = w2;	printf("max_hrs_to_repair_OH_line                   %8.0lf\n", line_repair_limit);
	scanf("%lf", &w2); cable_repair_limit = w2;	printf("max_hrs_to_repair_cable                     %8.0lf\n", cable_repair_limit);
	/* read restoration time and cost data */
	scanf("%d", &u1);
	if (u1 != 1002) printf("error reading restoration data, read %d\n", u1); 
	else printf("restor\n ID fixcap pmvacap fixop pmvaop hr2restore\n");
	for (j = 0; j < RESTORPTS; j++){
		scanf("%d %lf %lf %lf %lf %lf", &u1, &w2, &w3, &w4, &w5, &w6);
		if (u1 != j) printf("error in index restoration data read %d expected %d\n", u1, j); 
		else printf(" %2d %6.2lf %6.4lf %6.2lf %6.4lf %7.3lf\n", u1, w2, w3, w4, w5, w6);
		fixcapm[j] = w2;
		permvacapm[j] = w3;
		fixopm[j] = w4;
		permvaopm[j] = w5;
		hr2restor[j] = w6;
	}
	/* read tx repair time and cost data */
	scanf("%d", &u1);
	if (u1 != 1003) printf("error reading tx repair data, read %d\n", u1); 
	else printf("tx repair\n ID hr2repair fixcap pmvacap fixop pmvaop sfixcap spmvacap sop\n");
	for (j = 0; j < REPAIRPTS; j++){
		scanf("%d %lf %lf %lf %lf %lf %lf %lf %lf", &u1, &w2, &w3, &w4, &w5, &w6, &w7, &w8, &w9);
		if (u1 != j + 1) printf("error in index tx repair data read %d expected %d\n", u1, j + 1);
		else printf(" %2d  %8.2lf %6.2lf %6.4lf %6.2lf %6.4lf %6.2lf %6.4lf %6.2lf\n", u1, w2, w3, w4, w5, w6, w7, w8, w9);
		txhr2rep[j] = w2;
		txfixcapm[j] = w3;
		txpermvacapm[j] = w4;
		txfixopm[j] = w5;
		txpermvaopm[j] = w6;
		txsparefixcap[j] = w7;
		txsparepermvacap[j] = w8;
		txspareop[j] = w9;
	}
	/* read line repair time and cost data */
	scanf("%d", &u1);
	if (u1 != 1004) printf("error reading ln repair data, read %d\n", u1); 
	else printf("ln repair\n ID ohhr2repair fixcap pmvacap fixop pmvaop ughr2repair fixcap pmvacap fixop pmvaop\n");
	for (j = 0; j < REPAIRPTS; j++){
		scanf("%d %lf %lf %lf %lf %lf %lf %lf %lf %lf %lf", &u1, &w2, &w3, &w4, &w5, &w6, &w7, &w8, &w9, &w10, &w11);
		if (u1 != j + 1) printf("error in index ln repair data read %d expected %d\n", u1, j + 1);
		else printf(" %2d    %8.2lf %6.2lf %6.4lf %6.2lf %6.4lf    %8.2lf %6.2lf %6.4lf %6.2lf %6.4lf\n", 
			u1, w2, w3, w4, w5, w6, w7, w8, w9, w10, w11);
		ohhr2rep[j] = w2;
		ohfixcapm[j] = w3;
		ohpermvacapm[j] = w4;
		ohfixopm[j] = w5;
		ohpermvaopm[j] = w6;
		ughr2rep[j] = w7;
		ugfixcapm[j] = w8;
		ugpermvacapm[j] = w9;
		ugfixopm[j] = w10;
		ugpermvaopm[j] = w11;
	}
	/* read load type multipliers */
	scanf("%d", &u1);
	if (u1 != 1005) printf("error reading load type multiplier data, read %d\n", u1); 
	else printf("load type multipliers\n ID txcost ohcost ugcost failrate linelen\n");
	for (j = 0; j < REPAIRPTS; j++){
		scanf("%lf %lf %lf %lf %lf", &w2, &w3, &w4, &w5, &w6);
		printf(" %2d %6.2lf %6.2lf %6.2lf %8.2lf %5.0lf\n", j, w2, w3, w4, w5, w6);
		txcostmult[j] = w2;
		ohcostmult[j] = w3;
		ugcostmult[j] = w4;
		failratemult[j] = w5;
		linelength[j] = w6;
	}
	/* read BSP-specific data, now including bsp-specifid LDC info */
	scanf("%d", &u1);
	bspread = u1;
	printf("BSP data\n bsp  maxdem #tx #ln loc length ugflag   lf     vcr MVA/ln LDC points ...\n");
	for (j = 0; j < bspread; j++){
		scanf("%d %lf %d %d %d %lf %d %lf %lf %lf %lf %lf %lf %lf %lf %lf %lf %lf %lf %lf",
			&u1, &w2, &u3, &u6, &u7, &w7, &u2, &w10, &w11,&v0,&v1,&v2,&v3,&v4,&v5,&v6,&v7,&v8,&v9,&v10);
		label[j] = u1;
		max_demand[j] = w2;
		num_tx[j] = u3;
		num_ln[j] = u6;
		loctyp[j] = u7;
		if ((u7 < 0) || (u7 >= REPAIRPTS)) loctyp[j] = 2; /* default to regional if loctyp value is out of range */
		line_length[j] = w7;
		ugflag[j] = u2;
		load_factor[j] = w10;
		vcr[j] = w11;
		eabove[j][0] = v0;
		eabove[j][1] = v1;
		eabove[j][2] = v2;
		eabove[j][3] = v3;
		eabove[j][4] = v4;
		eabove[j][5] = v5;
		eabove[j][6] = v6;
		eabove[j][7] = v7;
		eabove[j][8] = v8;
		eabove[j][9] = v9;
		eabove[j][10] = v10;
		if (u1 != j + 1) printf("error in index BSP data read %d expected %d\n", u1, j + 1);
		else printf(" %3d %7.1lf %3d %3d %3d %6.0lf %6d %4.2lf %7.0lf %5.3lf %5.3lf %5.3lf %5.3lf %5.3lf %5.3lf %5.3lf %5.3lf %5.3lf %5.3lf %5.3lf\n", 
			u1, w2, u3, u6, u7, w7, u2, w10, w11, 
			eabove[j][0], eabove[j][1], eabove[j][2], eabove[j][3], eabove[j][4], eabove[j][5], 
			eabove[j][6], eabove[j][7], eabove[j][8], eabove[j][9], eabove[j][10]);
	}
	return;
}

void write_results(char bsp)
{
	printf(" %3d,%9.2lf,%8.2lf,%2.0lf,%2.0lf,N-%1d,%9.2lf,%8.2lf,,N2 %9.5lf,%9.5lf,N1 %9.5lf,%9.5lf,N %9.5lf,%9.5lf,%4.1lf,%4.1lf,%4.1lf,%4.1lf,%4.1lf,%4.1lf\n", 
		label[bsp], max_demand[bsp], vcr[bsp], omodnum_tx, omodnum_ln,
		opt_conting[bsp], mintotcost[bsp], optim_EUE[bsp],
		tot_cost[bsp][2], opt_EUE[bsp][2], 
		tot_cost[bsp][1], opt_EUE[bsp][1], 
		tot_cost[bsp][0], opt_EUE[bsp][0],
		LAR[bsp][0][2][opt_conting[bsp]],
		LAR[bsp][0][1][opt_conting[bsp]],
		LAR[bsp][0][0][opt_conting[bsp]],
		LAR[bsp][1][2][opt_conting[bsp]],
		LAR[bsp][1][1][opt_conting[bsp]],
		LAR[bsp][1][0][opt_conting[bsp]]);
		return;
}

double annuity(double capital, double d, double life)
{
	double value;

	value = capital * d / (1 + d) / (1 - pow(1 + d,-life));
	return value;
}

double e_above_load_point(char bsp, double x)
{ /* Per cent energy above load point. Determined by interpolating LDC points */
	double e, y, x1, x2, y1, y2;
	int ix1, ix2;

	if (x < 0.0) e = 1.0;
	else{
		if (x>1.0) e = 0.0;
		else{
			ix1 = 10 * x;
			ix2 = ix1 + 1;
			x1 = ix1 / 10.0;
			x2 = ix2 / 10.0;
			if (x < x1) {
				ix1--;
				ix2--;
			}
			if (x > x2) {
				ix1++;
				ix2++;
			}
			if (ix2 >= 10){
				ix2 = 10;
				ix1 = 9;
			}
			if (ix1 <= 0){
				ix1 = 0;
				ix2 = 1;
			}
			x1 = ix1 / 10.0;
			x2 = ix2 / 10.0;
			if ((ix2 - ix1) != 1) printf("error e_above_load_point bsp = %d, x= %f\n", bsp, x);
			if ((x < x1) || (x>x2)) printf("error e_above_load_point bsp = %d, x= %f, x1= %f, x2= %f\n", bsp, x, x1, x2);
			y1 = eabove[bsp][ix1];
			y2 = eabove[bsp][ix2];
			y = y1 + (x - x1)*(y2 - y1) / (x2 - x1); /* interpolation of LDC */
			e = max(y, 0.0);
		}
	}
	return e;
}

double mod_num_assets(int nasset, int isN_1defined, int res1, int isN_2defined, int res2)
{
	double modnum;

	/*  provided some tx or lines are originally called for,
	this function ensures that there are enough of these assets
	to cater for N-2 or N-1 requirements, if invoked.
	Also, if res1 or res2 = 0, then one more transformer will be needed */
	if (nasset == 0) modnum = 0.0;
	else {
		if ((isN_2defined == 1) && (res2 == 0)) modnum = 1.0*imax(3, nasset);
		else{
			if ((isN_2defined == 1) && (res2 >= 1)) modnum = 1.0*imax(2, nasset);
			else{
				if ((isN_1defined == 1) && (res1 == 0)) modnum = 1.0*imax(2, nasset);
				else modnum = 1.0*nasset;
			}
		}
	}
	return modnum;
}

double calc_N_1EUE(char bsp,double mod_num_assets,double unit_MVA_assets,double mult,
	double failrate, double hr2restoreN_1, double hr2repairN_1, double rest_cap_switch_N1)
{
	double N_1EUE,x,y;

	x = (mod_num_assets - 1)*unit_MVA_assets / max_demand[bsp];
	y = ((mod_num_assets - 1)*unit_MVA_assets + rest_cap_switch_N1) / max_demand[bsp];
	N_1EUE = max_demand[bsp] * load_factor[bsp] * mod_num_assets*failrate*mult
		*(e_above_load_point(bsp, x)*hr2restoreN_1
		+ e_above_load_point(bsp, y)*max((hr2repairN_1 - hr2restoreN_1), 0.0));
	return N_1EUE;
}

double calc_N_2EUE(char bsp,double mod_num_assets,double unit_MVA_assets,double mult,
	double failrate,double hr2restoreN_1,double hr2restoreN_2,double hr2repairN_1,double hr2repairN_2,
	double rest_cap_switch_N1,double rest_cap_switch_N2)
{
	double N_2EUE,x,y,xx,yy;

	x = (mod_num_assets - 2)*unit_MVA_assets / max_demand[bsp];
	y = ((mod_num_assets - 2)*unit_MVA_assets + rest_cap_switch_N1) / max_demand[bsp];
	xx = ((mod_num_assets - 2)*unit_MVA_assets + rest_cap_switch_N1 + rest_cap_switch_N2) / max_demand[bsp];
	yy = ((mod_num_assets - 1)*unit_MVA_assets + rest_cap_switch_N1) / max_demand[bsp];
	N_2EUE = max_demand[bsp] * load_factor[bsp]*failrate*failrate*mult*mult*hr2repairN_1
		*0.5*mod_num_assets*(mod_num_assets - 1) /* to account for the possible combinations of failures */
		*(e_above_load_point(bsp, x)*hr2restoreN_1
		+ e_above_load_point(bsp, y)*max((hr2restoreN_2 - hr2restoreN_1), 0.0)
		+ e_above_load_point(bsp, xx)*max((hr2repairN_1 - hr2restoreN_2), 0.0)
		+ e_above_load_point(bsp, yy)*max((hr2repairN_2 - hr2repairN_1), 0.0)) / (24.0 * 365);
	return N_2EUE;
}

double calc_cost(char bsp, double txlar1, int txrep1, double txlar2, int txrep2, 
	double llar1, int lrep1, double llar2, int lrep2,	int res1, int res2, 
	int txn, int linen, int N_1defined, int N_2defined)
{
	double hr2restoreN_1, hr2repairN_1, failrate, hr2restoreN_2, hr2repairN_2, cost,
		normal_EUE_tx, N_1event_EUE_tx, N_2event_EUE_tx,
		normal_EUE_ln, N_1event_EUE_ln, N_2event_EUE_ln,
		substation_capital_tx, substation_capital_ln,
		rest_cap_switch_N1,rest_cap_switch_N2,
		rest_cap_switch_N1_tx,rest_cap_switch_N2_tx,
		rest_cap_switch_N1_ln,rest_cap_switch_N2_ln,
		normal_repair_capital, normal_repair_opex,
		capital_tx, opex_tx, capital_ln, opex_ln,
		N_1repair_capital,N_2repair_capital,
		N_1switching_capital,N_2switching_capital,
		N_1switching_opex,N_2switching_opex,
		N_1restor_capacity,N_2restor_capacity,
		N_1repair_opex,N_2repair_opex,larNtx, larNln;
	double mod_num_tx, mod_num_ln,unit_MVA_tx,unit_MVA_ln,
		sscap_tx,sscap_ln,loadpt_tx,loadpt_ln,line_limit,linelife;
	double sctmult, sclmult, syst_cost;
	int itx, iln, tx_det_rest1,tx_det_rest2;

	/* calculate EUE costs */
	itx = num_tx[bsp];
	iln = num_ln[bsp];
	mod_num_tx = mod_num_assets(itx, N_1defined, res1, N_2defined, res2);
	mod_num_ln = mod_num_assets(iln, N_1defined, res1, N_2defined, res2);
	cmodnum_tx = mod_num_tx;
	cmodnum_ln = mod_num_ln;
	if(cmodnum_tx < 1.0*itx) printf("#tx reduced bsp = %d\n",bsp);
	if(cmodnum_ln < 1.0*iln) printf("#ln reduced bsp = %d\n",bsp);

	larNtx = ZERO;
	larNln = ZERO;
	bspLAR[0][0][N_2defined + 1] = larNtx;
	bspLAR[1][0][N_2defined + 1] = larNln;
	bspLAR[0][1][N_2defined + 1] = txlar1;
	bspLAR[1][1][N_2defined + 1] = llar1;
	bspLAR[0][2][N_2defined + 1] = txlar2;
	bspLAR[1][2][N_2defined + 1] = llar2;

	failrate = tx_fail_rate;
	hr2restoreN_1 = hr2restor[res1];
	hr2repairN_1 = txhr2rep[txrep1-1];
	if(res1==0) { /* res1 = 0 means no switching */
		rest_cap_switch_N1_tx = 0.0;
		rest_cap_switch_N1_ln = 0.0;
		rest_cap_switch_N1 = max(rest_cap_switch_N1_tx,rest_cap_switch_N1_ln);
		tx_det_rest1 = 1;
		sscap_tx = max(1-larNtx,(1-txlar1)*mod_num_tx/(mod_num_tx - 1))*max_demand[bsp];
		sscap_ln = max(1-larNln,(1-llar1)*mod_num_ln/(mod_num_ln - 1))*max_demand[bsp];
	}else { /* restoration capacity that needs to be provided by switching */
		if((N_1defined == 1) && (mod_num_tx > 0.0) && (mod_num_ln > 0.0)) {
			rest_cap_switch_N1_tx = max_demand[bsp]*max(0.0,
				((1-txlar1)-(1-larNtx)*(mod_num_tx-1)/mod_num_tx)); 
			rest_cap_switch_N1_ln = max_demand[bsp]*max(0.0,
				((1-llar1)-(1-larNln)*(mod_num_ln-1)/mod_num_ln)); 
		}
		else if ((N_1defined == 1) && (mod_num_ln > 0.0)){
			rest_cap_switch_N1_tx = 0.0;
			rest_cap_switch_N1_ln = max_demand[bsp] * max(0.0,
				((1 - llar1) - (1 - larNln)*(mod_num_ln - 1) / mod_num_ln));
		}
		else {
			rest_cap_switch_N1_tx =0.0;
			rest_cap_switch_N1_ln =0.0;
		}
		rest_cap_switch_N1 = max(rest_cap_switch_N1_tx,rest_cap_switch_N1_ln);
		if(rest_cap_switch_N1_tx >= rest_cap_switch_N1_ln) {
			tx_det_rest1 = 1;
		}else{ 
			tx_det_rest1 = 0;
		}
		sscap_tx = (1-larNtx)*max_demand[bsp];
		sscap_ln = (1-larNln)*max_demand[bsp];
	}
	if (mod_num_tx > 0) unit_MVA_tx = sscap_tx / mod_num_tx; else unit_MVA_tx = 0.0;
	if (mod_num_ln > 0) unit_MVA_ln = sscap_ln / mod_num_ln; else unit_MVA_ln = 0.0;
	loadpt_tx = sscap_tx/max_demand[bsp];
	loadpt_ln = sscap_ln/max_demand[bsp];
	normal_EUE_tx = e_above_load_point(bsp, min(1.0, max(0.0, loadpt_tx)))
		*max_demand[bsp]*load_factor[bsp]*24.0*365.0;
	normal_EUE_ln = e_above_load_point(bsp, min(1.0, max(0.0, loadpt_ln)))
		*max_demand[bsp] * load_factor[bsp] * 24.0*365.0;

	N_1event_EUE_tx = calc_N_1EUE(bsp,mod_num_tx,unit_MVA_tx,1.0,failrate,hr2restoreN_1,hr2repairN_1,rest_cap_switch_N1);

	if (N_2defined == 1){  
		if(res2==0){
			rest_cap_switch_N2_tx = 0.0;
			rest_cap_switch_N2_ln = 0.0;
			tx_det_rest2 = 1;
			rest_cap_switch_N2 = max(rest_cap_switch_N2_tx,rest_cap_switch_N2_ln);
			sscap_tx = max_demand[bsp] * max(1 - larNtx,
				max((1-txlar1)*mod_num_tx/(mod_num_tx-1),(1-txlar2)*mod_num_tx/(mod_num_tx-2)));
			if (mod_num_tx > 0) unit_MVA_tx = sscap_tx / mod_num_tx; else unit_MVA_tx = 0.0;
			sscap_ln = max_demand[bsp] * max(1 - larNln,
				max((1-llar1)*mod_num_ln/(mod_num_ln-1),(1-llar2)*mod_num_ln/(mod_num_ln-2)));
			if (mod_num_ln > 0) unit_MVA_ln = sscap_ln / mod_num_ln; else unit_MVA_ln = 0.0;
			loadpt_tx = sscap_tx / max_demand[bsp];
			loadpt_ln = sscap_ln/max_demand[bsp];
			normal_EUE_tx = e_above_load_point(bsp, min(1.0, max(0.0, loadpt_tx)))
				*max_demand[bsp] * load_factor[bsp] * 24.0*365.0;
			normal_EUE_ln = e_above_load_point(bsp, min(1.0, max(0.0, loadpt_ln)))
				*max_demand[bsp] * load_factor[bsp] * 24.0*365.0;
		}
		else{
			if (mod_num_tx > 1.0) {
				rest_cap_switch_N2_tx = max(0.0, max_demand[bsp]*
					((1 - txlar2) - (1 - larNtx)*(mod_num_tx - 2) / mod_num_tx) - rest_cap_switch_N1_tx);
			} else rest_cap_switch_N2_tx = 0.0;
			if (mod_num_ln > 1.0) {
				rest_cap_switch_N2_ln = max(0.0, max_demand[bsp]*
					((1 - llar2) - (1 - larNln)*(mod_num_ln - 2) / mod_num_ln) - rest_cap_switch_N1_ln);
			} else rest_cap_switch_N2_ln = 0.0;
			rest_cap_switch_N2 = max(rest_cap_switch_N2_tx, rest_cap_switch_N2_ln);
			if (rest_cap_switch_N2_tx >= rest_cap_switch_N2_ln)	{
				tx_det_rest2 = 1; 
			}
			else {
				tx_det_rest2 = 0; 
			}
		}
		hr2repairN_2 = txhr2rep[txrep2-1];
		hr2restoreN_2 = hr2restor[res2];
		N_2event_EUE_tx = calc_N_2EUE(bsp,mod_num_tx,unit_MVA_tx,1.0,
			failrate,hr2restoreN_1,hr2restoreN_2,hr2repairN_1,hr2repairN_2,rest_cap_switch_N1,rest_cap_switch_N2);
	}
	else {
		rest_cap_switch_N2_tx = 0.0;
		rest_cap_switch_N2_ln = 0.0;
		rest_cap_switch_N2 = max(rest_cap_switch_N2_tx,rest_cap_switch_N2_ln);
		tx_det_rest2 = 1;
		N_2event_EUE_tx = calc_N_2EUE(bsp, mod_num_tx, unit_MVA_tx, 1.0, 
			failrate, hr2restoreN_1, 0, hr2repairN_1, tx_repair_limit, rest_cap_switch_N1, rest_cap_switch_N2);
	} 

	if (ugflag[bsp] == 1) {
		line_limit = cable_repair_limit; 
		hr2repairN_1 = ughr2rep[lrep1-1];
		failrate = ugline_fail_rate;
	}
	else {
		line_limit = line_repair_limit;	
		hr2repairN_1 = ohhr2rep[lrep1-1];
		failrate = ohline_fail_rate;
	}

	N_1event_EUE_ln = calc_N_1EUE(bsp,mod_num_ln,unit_MVA_ln,line_length[bsp]/100.0,
		failrate,hr2restoreN_1,hr2repairN_1,rest_cap_switch_N1);
	 
	if (N_2defined == 1){ 
		if (ugflag[bsp] == 1) hr2repairN_2 = ughr2rep[lrep2-1]; else hr2repairN_2 = ohhr2rep[lrep2-1];
		hr2restoreN_2 = hr2restor[res2];
		N_2event_EUE_ln = calc_N_2EUE(bsp,mod_num_ln,unit_MVA_ln,line_length[bsp]/100.0,
			failrate,hr2restoreN_1,hr2restoreN_2,hr2repairN_1,hr2repairN_2,	rest_cap_switch_N1, rest_cap_switch_N2);
	}
	else {
		hr2repairN_2 = line_limit;
		N_2event_EUE_ln = calc_N_2EUE(bsp, mod_num_ln, unit_MVA_ln, line_length[bsp] / 100.0,
			failrate, hr2restoreN_1, 0, hr2repairN_1, hr2repairN_2, rest_cap_switch_N1, rest_cap_switch_N2);
	}
	 
	EUE = normal_EUE_tx + N_1event_EUE_tx + N_2event_EUE_tx 
		+ normal_EUE_ln + N_1event_EUE_ln + N_2event_EUE_ln;
	
	oEUE0tx = normal_EUE_tx;
	oEUE1tx = N_1event_EUE_tx;
	oEUE2tx = N_2event_EUE_tx;
	oEUE0ln = normal_EUE_ln;
	oEUE1ln = N_1event_EUE_ln;
	oEUE2ln = N_2event_EUE_ln;
	orestcapswtx2 = rest_cap_switch_N2_tx;
	orestcapswtx1 = rest_cap_switch_N1_tx;
	orestcapswln2 = rest_cap_switch_N2_ln;
	orestcapswln1 = rest_cap_switch_N1_ln;

	/* calculate system costs */
	/* for transformers */
	substation_capital_tx = mod_num_tx*TRANSFORMERCOSTMULT*tx_cost_coef
		*pow((double) unit_MVA_tx,(double) tx_cost_exp);
	substation_capital_ln = mod_num_ln*LINECOSTMULT*line_length[bsp] * ln_cost_coef
		*pow((double)unit_MVA_ln, (double)ln_cost_exp);
	if (ugflag[bsp] == 1) substation_capital_ln = substation_capital_ln*ug_cost_mult;

	N_1repair_capital	= txfixcapm[txrep1-1] +unit_MVA_tx * txpermvacapm[txrep1-1];
	N_1repair_opex		= (txfixopm[txrep1-1] + unit_MVA_tx * txpermvaopm[txrep1-1])
		*tx_fail_rate + N_1repair_capital*OPEX_CAPITAL;

	if(tx_det_rest1 == 1){
		N_1switching_capital = fixcapm[res1] + rest_cap_switch_N1_tx*permvacapm[res1];
		N_1switching_opex = fixopm[res1] + rest_cap_switch_N1_tx*permvaopm[res1];
	}
	else {
		N_1switching_capital = 0.0;
		N_1switching_opex = 0.0;
	}
	if((mod_num_tx > 0.0)&&(tx_det_rest1 == 1)) 
		N_1restor_capacity = rest_cap_switch_N1_tx*capefffactor*
		(substation_capital_tx / sscap_tx + substation_capital_ln / sscap_ln) / 2.0;
	else N_1restor_capacity = 0.0;

	if (N_2defined == 1){
		N_2repair_capital	= txfixcapm[txrep2-1] +unit_MVA_tx * txpermvacapm[txrep2-1];
		N_2repair_opex		= (txfixopm[txrep2-1] + unit_MVA_tx * txpermvaopm[txrep2-1])
			*tx_fail_rate*tx_fail_rate + N_2repair_capital*OPEX_CAPITAL;

		if((tx_det_rest2 == 1)&&(rest_cap_switch_N2_tx > 0)) {
			N_2switching_capital = fixcapm[res2] + rest_cap_switch_N2_tx*permvacapm[res2];
			N_2switching_opex = fixopm[res2] + rest_cap_switch_N2_tx*permvaopm[res2];
		}
		else {
			N_2switching_capital = 0.0;
			N_2switching_opex = 0.0;
		}
		if((mod_num_tx > 0.0)&&(tx_det_rest2 == 1)) 
			N_2restor_capacity = rest_cap_switch_N2_tx*capefffactor*
			(substation_capital_tx / sscap_tx + substation_capital_ln / sscap_ln) / 2.0; 
		else N_2restor_capacity = 0.0; 
	}
	else {
		N_2repair_capital = 0.0;
		N_2switching_capital = 0.0;
		N_2switching_opex = 0.0;
		N_2restor_capacity = 0.0;
		N_2repair_opex = 0.0;
	}
	normal_repair_capital = 0.0;

	capital_tx = substation_capital_tx
		+ normal_repair_capital + N_1restor_capacity + N_1switching_capital + N_1repair_capital
		+ N_2restor_capacity + N_2switching_capital + N_2repair_capital;

	normal_repair_opex = 0.0; 

	opex_tx = (substation_capital_tx +  normal_repair_capital + N_1restor_capacity 
		+ N_1switching_capital + N_2restor_capacity + N_2switching_capital)*OPEX_CAPITAL
		+ normal_repair_opex + N_1repair_opex + N_2repair_opex
		+ N_1switching_opex + N_2switching_opex;

	/* for lines */
	if(tx_det_rest1 == 0){
		N_1switching_capital = fixcapm[res1] + rest_cap_switch_N1_ln*permvacapm[res1];
		N_1switching_opex = fixopm[res1] + rest_cap_switch_N1_ln*permvaopm[res1];
	}
	else {
		N_1switching_capital = 0.0;
		N_1switching_opex = 0.0;
	}
	if((mod_num_tx > 0.0)&&(tx_det_rest1 == 0)) 
		N_1restor_capacity = rest_cap_switch_N1_ln*capefffactor*
		(substation_capital_tx / sscap_tx + substation_capital_ln / sscap_ln) / 2.0;
	else if(mod_num_tx <= 0.0) 
		N_1restor_capacity = rest_cap_switch_N1_ln*capefffactor*
		(substation_capital_ln / sscap_ln) / 2.0;
	else N_1restor_capacity = 0.0;
	if(N_2defined == 1) {
		if((tx_det_rest2 == 0)&&(rest_cap_switch_N2_ln > 0)) {
			N_2switching_capital = fixcapm[res2] + rest_cap_switch_N2_ln*permvacapm[res2];
			N_2switching_opex = fixopm[res2] + rest_cap_switch_N2_ln*permvaopm[res2];
		}
		else {
			N_2switching_capital = 0.0;
			N_2switching_opex = 0.0;
		}
		if((mod_num_tx > 0.0)&&(tx_det_rest2 == 0)) 
			N_2restor_capacity = rest_cap_switch_N2_ln*capefffactor*
			(substation_capital_tx / sscap_tx + substation_capital_ln / sscap_ln) / 2.0; 
		else if(mod_num_tx <= 0.0)
			N_2restor_capacity = rest_cap_switch_N2_ln*capefffactor*
			(substation_capital_ln / sscap_ln) / 2.0; 
		else N_2restor_capacity = 0.0;
	}

	/* oh lines */
	if (ugflag[bsp] == 0){ /* oh lines */
		N_1repair_capital	= ohfixcapm[lrep1-1] +unit_MVA_ln * ohpermvacapm[lrep1-1];
		N_1repair_opex		= (ohfixopm[lrep1-1] + unit_MVA_ln * ohpermvaopm[lrep1-1])
			*ohline_fail_rate*line_length[bsp]/100.0 +N_1repair_capital*OPEX_CAPITAL;

		if (N_2defined == 1){
			N_2repair_capital	= ohfixcapm[lrep2-1] +unit_MVA_ln * ohpermvacapm[lrep2-1];
			N_2repair_opex		= (ohfixopm[lrep2-1] + unit_MVA_ln * ohpermvaopm[lrep2-1])
				*ohline_fail_rate*ohline_fail_rate*line_length[bsp]*line_length[bsp]/10000.0 + N_2repair_capital*OPEX_CAPITAL;
		}
		else{
			N_2repair_capital = 0.0;
			N_2restor_capacity = 0.0;
			N_2repair_opex = 0.0;
		}
		normal_repair_capital = 0.0;
		normal_repair_opex = 0.0;
	}
	else{ /* ug lines */
		N_1repair_capital	= ugfixcapm[lrep1-1] +unit_MVA_ln * ugpermvacapm[lrep1-1];
		N_1repair_opex		= (ugfixopm[lrep1-1] + unit_MVA_ln * ugpermvaopm[lrep1-1])
			*ugline_fail_rate*line_length[bsp]/100.0 +N_1repair_capital*OPEX_CAPITAL;

		if (N_2defined == 1){
			N_2repair_capital	= ugfixcapm[lrep2-1] +unit_MVA_ln * ugpermvacapm[lrep2-1];
			N_2repair_opex		= (ugfixopm[lrep2-1] + unit_MVA_ln * ugpermvaopm[lrep2-1])
				*ugline_fail_rate*ugline_fail_rate*line_length[bsp]*line_length[bsp]/10000.0 + N_2repair_capital*OPEX_CAPITAL;
		}
		else{
			N_2repair_capital = 0.0;
			N_2restor_capacity = 0.0;
			N_2repair_opex = 0.0;
		}
		normal_repair_capital = 0.0;
		normal_repair_opex = 0.0;
	}

	capital_ln = substation_capital_ln
		+ normal_repair_capital	+ N_1restor_capacity + N_1switching_capital + N_1repair_capital
		+ N_2restor_capacity + N_2switching_capital + N_2repair_capital;

	opex_ln = (substation_capital_ln + N_1restor_capacity + normal_repair_capital
		+ N_1switching_capital + N_2restor_capacity + N_2switching_capital)*OPEX_CAPITAL
		+ normal_repair_opex + N_1repair_opex + N_2repair_opex
		+ N_1switching_opex + N_2switching_opex;

	sctmult = txcostmult[loctyp[bsp]];
	if (ugflag[bsp] == 1) {
		sclmult = ugcostmult[loctyp[bsp]];
		linelife = UGLINELIFE;
	}
	else {
		sclmult = ohcostmult[loctyp[bsp]];
		linelife = OHLINELIFE;
	}
	syst_cost = (opex_tx + annuity(capital_tx, discrate, TRANSFORMERLIFE))*sctmult
				+ (opex_ln + annuity(capital_ln, discrate, linelife))*sclmult;

	/* calculate total social cost */
		/* vcr is in $/MWh, but needs to be in $m/MWh */
		/* last two terms are the Nuttall tie-breaker mechanism */
	cost = syst_cost + EUE*vcr[bsp] / 1e+6 + (txlar1+llar1+txlar2+llar2)/10000.0 + (res1+res2)/25000.0;

	return cost;
}

double calc_costN(char bsp, double txlar, int txrep, double llar, int lrep)
{
	double hr2repairN_1, failrate, hr2repairN_2, cost,
		normal_EUE_tx, N_1event_EUE_tx, N_2event_EUE_tx,
		normal_EUE_ln, N_1event_EUE_ln, N_2event_EUE_ln,
		substation_capital_tx, substation_capital_ln,
		rest_cap_switch_N1,rest_cap_switch_N2,
		rest_cap_switch_N1_tx,rest_cap_switch_N2_tx,
		rest_cap_switch_N1_ln,rest_cap_switch_N2_ln,
		normal_repair_capital, normal_repair_opex,
		capital_tx, opex_tx, capital_ln, opex_ln,
		N_1repair_capital,N_2repair_capital,
		N_1switching_capital,N_2switching_capital,
		N_1switching_opex,N_2switching_opex,
		N_1restor_capacity,N_2restor_capacity,
		N_1repair_opex,N_2repair_opex,larNtx, larNln;
	double mod_num_tx, mod_num_ln,unit_MVA_tx,unit_MVA_ln,
		sscap_tx,sscap_ln,loadpt_tx,loadpt_ln,line_limit;
	double sctmult, sclmult, syst_cost, linelife;
	int itx, iln, tx_det_rest;

	/* calculate EUE costs */
	itx = num_tx[bsp];
	iln = num_ln[bsp];
	mod_num_tx = mod_num_assets(itx, 0,0,0,0);
	mod_num_ln = mod_num_assets(iln, 0,0,0,0);
	cmodnum_tx = mod_num_tx;
	cmodnum_ln = mod_num_ln;
	if(cmodnum_tx < 1.0*itx) printf("#tx reduced bsp = %d\n",bsp);
	if(cmodnum_ln < 1.0*iln) printf("#ln reduced bsp = %d\n",bsp);

	larNtx = txlar;
	larNln = llar;
	bspLAR[0][0][0] = larNtx;
	bspLAR[1][0][0] = larNln;
	bspLAR[0][1][0] = 0;
	bspLAR[1][1][0] = 0;
	bspLAR[0][2][0] = 0;
	bspLAR[1][2][0] = 0;

	failrate = tx_fail_rate;
	hr2repairN_1 = txhr2rep[txrep-1];
	hr2repairN_2 = txhr2rep[txrep-1];
	rest_cap_switch_N1_tx = 0.0;
	rest_cap_switch_N1_ln = 0.0;
	rest_cap_switch_N1 = max(rest_cap_switch_N1_tx,rest_cap_switch_N1_ln);
	tx_det_rest = 1;
	sscap_tx = (1-larNtx)*max_demand[bsp];
	sscap_ln = (1-larNln)*max_demand[bsp];
	if (mod_num_tx > 0) unit_MVA_tx = sscap_tx / mod_num_tx; else unit_MVA_tx = 0.0;
	if (mod_num_ln > 0) unit_MVA_ln = sscap_ln / mod_num_ln; else unit_MVA_ln = 0.0;
	loadpt_tx = sscap_tx/max_demand[bsp];
	loadpt_ln = sscap_ln/max_demand[bsp];
	normal_EUE_tx = e_above_load_point(bsp, min(1.0, max(0.0, loadpt_tx)))
		*max_demand[bsp]*load_factor[bsp]*24.0*365.0;
	normal_EUE_ln = e_above_load_point(bsp, min(1.0, max(0.0, loadpt_ln)))
		*max_demand[bsp] * load_factor[bsp] * 24.0*365.0;

	N_1event_EUE_tx = calc_N_1EUE(bsp,mod_num_tx,unit_MVA_tx,1.0,failrate,0,hr2repairN_1,rest_cap_switch_N1);

	rest_cap_switch_N2_tx = 0.0;
	rest_cap_switch_N2_ln = 0.0;
	rest_cap_switch_N2 = max(rest_cap_switch_N2_tx,rest_cap_switch_N2_ln);
	tx_det_rest = 1;
	N_2event_EUE_tx = calc_N_2EUE(bsp, mod_num_tx, unit_MVA_tx, 1.0, 
		failrate, 0, 0, hr2repairN_1, tx_repair_limit, rest_cap_switch_N1, rest_cap_switch_N2);

	if (ugflag[bsp] == 1) {
		hr2repairN_1 = ughr2rep[lrep-1]; 
		failrate = ugline_fail_rate;
		line_limit = cable_repair_limit;
	}
	else {
		hr2repairN_1 = ohhr2rep[lrep-1];
		failrate = ohline_fail_rate;
		line_limit = line_repair_limit;
	}

	N_1event_EUE_ln = calc_N_1EUE(bsp,mod_num_ln,unit_MVA_ln,line_length[bsp]/100.0,
		failrate,0,hr2repairN_1,rest_cap_switch_N1);
	 
	if (ugflag[bsp] == 1) hr2repairN_2 = cable_repair_limit; else hr2repairN_2 = line_repair_limit;		
	N_2event_EUE_ln = calc_N_2EUE(bsp, mod_num_ln, unit_MVA_ln, line_length[bsp] / 100.0,
		failrate, 0, 0, hr2repairN_1, line_limit, rest_cap_switch_N1, rest_cap_switch_N2);
	 
	EUE = normal_EUE_tx + N_1event_EUE_tx + N_2event_EUE_tx 
		+ normal_EUE_ln + N_1event_EUE_ln + N_2event_EUE_ln;
	
	oEUE0tx = normal_EUE_tx;
	oEUE1tx = N_1event_EUE_tx;
	oEUE2tx = N_2event_EUE_tx;
	oEUE0ln = normal_EUE_ln;
	oEUE1ln = N_1event_EUE_ln;
	oEUE2ln = N_2event_EUE_ln;

	/* calculate system costs */
	/* for transformers */
	substation_capital_tx = mod_num_tx*TRANSFORMERCOSTMULT*tx_cost_coef
		*pow((double) unit_MVA_tx,(double) tx_cost_exp);
	substation_capital_ln = mod_num_ln*LINECOSTMULT*line_length[bsp] * ln_cost_coef
		*pow((double)unit_MVA_ln, (double)ln_cost_exp);
	if (ugflag[bsp] == 1) substation_capital_ln = substation_capital_ln*ug_cost_mult;

	normal_repair_capital	= txfixcapm[txrep-1] +unit_MVA_tx * txpermvacapm[txrep-1];
	normal_repair_opex		= (txfixopm[txrep-1] + unit_MVA_tx * txpermvaopm[txrep-1])
		*tx_fail_rate;

	N_1repair_capital = 0.0;
	N_1switching_capital = 0.0;
	N_1restor_capacity = 0.0;
	N_1switching_opex = 0.0;
	N_1repair_opex = 0.0;

	N_2repair_capital = 0.0;
	N_2switching_capital = 0.0;
	N_2restor_capacity = 0.0;
	N_2switching_opex = 0.0;
	N_2repair_opex = 0.0;

	capital_tx = substation_capital_tx
		+ normal_repair_capital + N_1restor_capacity + N_1switching_capital + N_1repair_capital
		+ N_2restor_capacity + N_2switching_capital + N_2repair_capital;

	opex_tx = (substation_capital_tx +  normal_repair_capital + N_1restor_capacity 
		+ N_1switching_capital + N_2restor_capacity + N_2switching_capital)*OPEX_CAPITAL
		+ normal_repair_opex + N_1repair_opex + N_2repair_opex
		+ N_1switching_opex + N_2switching_opex;

	/* for lines */

	/* oh lines */
	if (ugflag[bsp] == 0){ /* oh lines */
		normal_repair_capital	= ohfixcapm[lrep-1] +unit_MVA_ln * ohpermvacapm[lrep-1];
		normal_repair_opex		= (ohfixopm[lrep-1] + unit_MVA_ln * ohpermvaopm[lrep-1])
			*ohline_fail_rate*line_length[bsp]/100.0;
	}
	else{ /* ug lines */
		normal_repair_capital	= ugfixcapm[lrep-1] +unit_MVA_ln * ugpermvacapm[lrep-1];
		normal_repair_opex		= (ugfixopm[lrep-1] + unit_MVA_ln * ugpermvaopm[lrep-1])
			*ugline_fail_rate*line_length[bsp]/100.0;
	}

	N_1repair_capital = 0.0;
	N_1switching_capital = 0.0;
	N_1restor_capacity = 0.0;
	N_1repair_opex = 0.0;

	N_2repair_capital = 0.0;
	N_2switching_capital = 0.0;
	N_2restor_capacity = 0.0;
	N_2repair_opex = 0.0;

	capital_ln = substation_capital_ln
		+ normal_repair_capital	+ N_1restor_capacity + N_1switching_capital + N_1repair_capital
		+ N_2restor_capacity + N_2switching_capital + N_2repair_capital;

	opex_ln = (substation_capital_ln + N_1restor_capacity + normal_repair_capital
		+ N_1switching_capital + N_2restor_capacity + N_2switching_capital)*OPEX_CAPITAL
		+ normal_repair_opex + N_1repair_opex + N_2repair_opex
		+ N_1switching_opex + N_2switching_opex;

	sctmult = txcostmult[loctyp[bsp]];
	if (ugflag[bsp] == 1) {
		sclmult = ugcostmult[loctyp[bsp]];
		linelife = UGLINELIFE;
	}
	else {
		sclmult = ohcostmult[loctyp[bsp]];
		linelife = OHLINELIFE;
	}
	syst_cost = (opex_tx + annuity(capital_tx, discrate, TRANSFORMERLIFE))*sctmult
				+ (opex_ln + annuity(capital_ln, discrate, linelife))*sclmult;

	/* calculate total social cost */
		/* vcr is in $/MWh, but needs to be in $m/MWh */
		/* last two terms are the Nuttall tie-breaker mechanism */
	cost = syst_cost + EUE*vcr[bsp] / 1e+6 + (txlar+llar)/10000.0;

	return cost;
}

void N_2_find_optimum(char bsp)
{
	int txN, lineN, lrep2, lrep1, txrep2, txrep1, res2, res1, iteration;
	int illar2, itxlar2; /* integer versions of these variables for loop indexation */
	double llar2, txlar2, cost, min_cost;

	min_cost = LARGENUMBER;
	opt_EUE[bsp][2] = LARGENUMBER;
	tot_cost[bsp][2] = min_cost;
	iteration = 0;
	for (txN = 0; txN < 2; txN++){
		for (lineN = 0; lineN < 2; lineN++){
			for (lrep2 = 4; lrep2 > 0; lrep2--){
				for (illar2 = 4; illar2 > -1; illar2--){
					llar2 = illar2 / 5.0;
					for (lrep1 = lrep2; lrep1 > 0; lrep1--){
						for (txrep2 = 4; txrep2 > 0; txrep2--){
							for (itxlar2 = 4; itxlar2 > -1; itxlar2--){
								txlar2 = itxlar2 / 5.0;
								for (txrep1 = txrep2; txrep1 > 0; txrep1--){
									for (res2 = 5; res2 > -1; res2--){
										for (res1 = res2; res1 > -1; res1--){
			/* indent reduced for readability */
			iteration++;
			cost = calc_cost(bsp, ZERO, txrep1, txlar2, txrep2, ZERO, lrep1, llar2, lrep2, 
				res1, res2, txN, lineN, 1, 1);
			if ((cost < 0.0)||(EUE<0.0)){
				cost = LARGENUMBER;
				EUE = LARGENUMBER;
			}
			if (cost < min_cost){
				olrep2 = lrep2; ollar2 = llar2; otxrep2 = txrep2; otxlar2 = txlar2;
				ores2 = res2; o2txrep1 = txrep1; o2lrep1 = lrep1;
				ores1 = res1; otxN = txN; olineN = lineN;
				min_cost = cost;
				opt_EUE[bsp][2] = EUE;
				orcstx2[bsp] = orestcapswtx2;
				orcstx1[bsp] = orestcapswtx1;
				orcsln2[bsp] = orestcapswln2;
				orcsln1[bsp] = orestcapswln1;
				LAR[bsp][0][0][2] = bspLAR[0][0][2];
				LAR[bsp][0][1][2] = bspLAR[0][1][2];
				LAR[bsp][0][2][2] = bspLAR[0][2][2];
				LAR[bsp][1][0][2] = bspLAR[1][0][2];
				LAR[bsp][1][1][2] = bspLAR[1][1][2];
				LAR[bsp][1][2][2] = bspLAR[1][2][2];
			}
			/* end of indent */
										}
									}
								}
							}
						}
					}
				}
			}
		}
	}
	tot_cost[bsp][2] = min_cost;
	return;
}

void N_1_find_optimum(char bsp)
{
	int txN, lineN, lrep1, txrep1, res1, iteration;
	int illar1, itxlar1; /* integer versions for indexation in loops */
	double llar1, txlar1, cost, min_cost;

	omodnum_tx=-9;
	omodnum_ln=-9;
	min_cost = LARGENUMBER;
	opt_EUE[bsp][1] = LARGENUMBER;
	tot_cost[bsp][1] = min_cost;
	iteration = 0;
	for (txN = 0; txN < 2; txN++){
		for (lineN = 0; lineN < 2; lineN++){
			for (illar1 = 9; illar1 > -1; illar1--){
				llar1 = illar1 / 10.0;
				for (lrep1 = 4; lrep1 > 0; lrep1--){
					for (itxlar1 = 9; itxlar1 > -1; itxlar1--){
						txlar1 = itxlar1 / 10.0;
						for (txrep1 = 4; txrep1 > 0; txrep1--){
							for (res1 = 5; res1 > -1; res1--){
		/* indent reduced for readability */
		iteration++;
		cost = calc_cost(bsp, txlar1, txrep1, ZERO, ZERO, llar1, lrep1, ZERO, ZERO, 
			res1, ZERO, txN, lineN, 1, 0);
		if ((cost < 0.0) || (EUE<0.0)){
			cost = LARGENUMBER;
			EUE = LARGENUMBER;
		}
		if (cost < min_cost){
			min_cost = cost;
			opt_EUE[bsp][1] = EUE;
			omodnum_tx = cmodnum_tx; omodnum_ln = cmodnum_ln;
			o_EUE_norm_tx[bsp] = oEUE0tx;
			o_EUE_N1_tx[bsp] = oEUE1tx;
			o_EUE_N2_tx[bsp] = oEUE2tx;
			o_EUE_norm_ln[bsp] = oEUE0ln;
			o_EUE_N1_ln[bsp] = oEUE1ln;
			o_EUE_N2_ln[bsp] = oEUE2ln;
			LAR[bsp][0][0][1] = bspLAR[0][0][1];
			LAR[bsp][0][1][1] = bspLAR[0][1][1];
			LAR[bsp][0][2][1] = bspLAR[0][2][1];
			LAR[bsp][1][0][1] = bspLAR[1][0][1];
			LAR[bsp][1][1][1] = bspLAR[1][1][1];
			LAR[bsp][1][2][1] = bspLAR[1][2][1];
		}
		/* end of indent */
							}
						}
					}
				}
			}
		}
	}
	tot_cost[bsp][1] = min_cost;
	return;
}

void N_find_optimum(char bsp)
{
	int lrep, txrep, iteration;
	int illar, itxlar; /* integer versions for indexation in loops */
	double llar, txlar, cost, min_cost;

	min_cost = LARGENUMBER;
	opt_EUE[bsp][0] = LARGENUMBER;
	tot_cost[bsp][0] = min_cost;
	iteration = 0;
	for (illar = 9; illar > -1; illar--){
		llar = illar / 10.0;
		for (lrep = 4; lrep > 0; lrep--){
			for (itxlar = 9; itxlar > -1; itxlar--){
				txlar = itxlar / 10.0;
				for (txrep = 4; txrep > 0; txrep--){
		/* indent reduced for readability */
		iteration++;
		cost = calc_costN(bsp, txlar, txrep, llar, lrep);
		if ((cost < 0.0) || (EUE<0.0)){
			cost = LARGENUMBER;
			EUE = LARGENUMBER;
		}
		if (cost < min_cost){
			min_cost = cost;
			opt_EUE[bsp][0] = EUE;
			LAR[bsp][0][0][0] = bspLAR[0][0][0];
			LAR[bsp][0][1][0] = bspLAR[0][1][0];
			LAR[bsp][0][2][0] = bspLAR[0][2][0];
			LAR[bsp][1][0][0] = bspLAR[1][0][0];
			LAR[bsp][1][1][0] = bspLAR[1][1][0];
			LAR[bsp][1][2][0] = bspLAR[1][2][0];
		}
		/* end of indent */
				}
			}
		}
	}
	tot_cost[bsp][0] = min_cost;
	return;
}

/* main program */
int main()
{
	char bsp;
	double mincost;

	read_inputs();
	printf(" bsp,max_demand, vcr   ,tx,ln,N-x,  mincost, opt_EUE,,  N2    cost       EUE,  N1    cost       EUE,  N    cost       EUE, txlar2 1 N  llar2 1 N\n");
	for (bsp = 0; bsp < NUMBSP; bsp++){
		mincost = LARGENUMBER;
		
		N_2_find_optimum(bsp);
		if ((tot_cost[bsp][2]>0) && (tot_cost[bsp][2] < mincost)){
			mincost = tot_cost[bsp][2];
			opt_conting[bsp] = 2;
			optim_EUE[bsp] = opt_EUE[bsp][2];
			mintotcost[bsp] = tot_cost[bsp][2];
		} 

		N_1_find_optimum(bsp);
		if ((tot_cost[bsp][1]>0)&&(tot_cost[bsp][1] < mincost)){
			mincost = tot_cost[bsp][1];
			opt_conting[bsp] = 1;
			optim_EUE[bsp] = opt_EUE[bsp][1];
			mintotcost[bsp] = tot_cost[bsp][1];
		}

		N_find_optimum(bsp);
		if (tot_cost[bsp][0] < mincost){
			mincost = tot_cost[bsp][0];
			opt_conting[bsp] = 0;
			optim_EUE[bsp] = opt_EUE[bsp][0];
			mintotcost[bsp] = tot_cost[bsp][0];
		} 
		write_results(bsp);
	}
}
